#!/bin/bash


TITLE="Linkat - Google Drive Backup"

yad --width=500 --height=300 --center \
	--title="$TITLE" \
	--text="\nVols configurar les copies de seguretat al núvol de Google?" \
	--image="/usr/share/linkat/linkat-gdlnadmin/linkat-gdlnadmin-banner.png" \
	--button="D'acord":0 --button="Cancel·la":11
res1="$?"

if [ "$res1" -gt 1 ]; then
        exit 11
fi

if [ ! -f /home/lnadmin/.gdfuse/default/state ]; then
	google-drive-ocamlfuse
	linkat-gdlnadmin mount
else
	yad --width=500 --height=300 --center \
 	       --title="$TITLE" \
        	--text="\nJa tens un compte de Google Drive asociat.\n Vols continuar amb aquest compte?" \
        	--image="/usr/share/linkat/linkat-gdlnadmin/linkat-gdlnadmin-banner.png" \
        	--button="D'acord":0 --button="Canvia":2
	Action="$?"
	case "$Action" in
		0)
			;;
		2)
			rm -rf /home/lnadmin/.gdfuse
			google-drive-ocamlfuse
			linkat-gdlnadmin
			;;
		*)	exit 11
	esac
fi

test -e /tmp/yadpipe03 && rm -f /tmp/yadpipe03

# Named pipe initialization
export PIPE_03=/tmp/yadpipe03
mkfifo $PIPE_03
exec 3<> $PIPE_03

function load_data
{
  DIRS="$(yad --file --multiple --width=800 --height=600 \
         --directory --title="Selecciona directoris")"

  OIFS=$IFS
  IFS="|"

  [[ ! -z "$DIRS" ]] && YAD_DATA=($(for DIR in "$DIRS";do echo "$DIR";done ))

  IFS=$OIFS

  for DATA in "${YAD_DATA[@]}";do
      echo True     # Adds "True" for the checklist column
      echo "${DATA}"
  done
}
export -f load_data

function clear_all
{
  echo -e '\f'
}
export -f clear_all

SERVER_DIRS=$(for i in $(ls /srv/exports/); do echo TRUE /srv/exports/$i; done)

## Seleccionar els directoris 
Record=($(yad --list --checklist --separator="|" --grid-lines=hor \
    --image="/usr/share/linkat/linkat-gdlnadmin/linkat-gdlnadmin-banner.png" \
    --width=500 --height=300 --center \
    --title="$TITLE" \
    --text="\nSelecciona els directoris dels que es vulguin realitzar les còpies de seguretat.\n" \
    --column "Seleccionar" --column "Directori" \
    --button="Afegir directori!gtk-add":'bash -c "load_data > $PIPE_03"' \
    --button="Buidar!gtk-clear":'bash -c "clear_all > $PIPE_03"' \
    --button="Acceptar!gtk-ok":0 \
    $SERVER_DIRS \
    --listen --print-all < "$PIPE_03" ))
Action="$?"


## Genera el fitxer de config
echo ${Record[@]} | fmt -1 | grep TRUE | awk -F "|" '{print $2}' > /home/lnadmin/.linkat-google-drive-backup
